#include "node.hpp"

#include <cmath>

/* 
Node::Node() {
    root_ = nullptr;
    parent_ = nullptr;
    particles_ = nullptr;
    nParticles_ = 0;
    depth_ = 0;
    size_ = 0;
    for (unsigned i=0; i<3; ++i) center_[i] = 0;
    localParticles_ = nullptr;
    nLocalParticles_ = 0;
    for (unsigned i=0; i<8; ++i) children_[i] = nullptr;
}
 */

Node::Node(Node* parent, double* masses, double* particles, unsigned nParticles, unsigned depth, double size, double center[3], unsigned* localParticles, unsigned nLocalParticles) {
    parent_ = parent;
    particles_ = particles;
    nParticles_ = nParticles;

    depth_ = depth;
    size_ = size;

    for (unsigned i=0; i<3; ++i) center_[i] = center[i];

    localParticles_ = localParticles;
    nLocalParticles_ = nLocalParticles;

    mass_ = 0;
    for (unsigned i=0; i<nLocalParticles; ++i) {
        mass_ += masses_[localParticles_[i]];
    }

    // allocate children
    // TODO
}

Node::~Node() {
    for (unsigned i=0; i<8; ++i) {
        delete children_[i];
    }
    delete[] localParticles_;
}

Node& Node::operator=(const Node& other) {
    root_ = other.root_;
    parent_ = other.parent_;
    particles_ = other.particles_;
    nParticles_ = other.nParticles_;
    depth_ = other.depth_;
    size_ = other.size_;
    for (unsigned i=0; i<3; ++i) center_[i] = other.center_[i];
    localParticles_ = other.localParticles_;
    nLocalParticles_ = other.nLocalParticles_;
    mass_ = other.mass_;
    for (unsigned i=0; i<8; ++i) children_[i] = other.children_[i];
    return *this;
}

double* Node::calculateForce(unsigned particle) {
    // calculate theta
    double lambda = std::sqrt((center_[0] - particles_[3*particle + 0])*(center_[0] - particles_[3*particle + 0])
                            + (center_[1] - particles_[3*particle + 1])*(center_[1] - particles_[3*particle + 1])
                            + (center_[2] - particles_[3*particle + 2])*(center_[2] - particles_[3*particle + 2]));
    double theta = size_/lambda;
    // if angle too large, calculate force on particle from children
    // else calculate force on particle from particles in this node
    if (theta > theta0_) {
        // TODO
    } else {
        // TODO
    }
    return nullptr;
}